
import GameLogic as gl
import socket
import OSC
from time import sleep

# init global var
ip = gl.ip_in
port = gl.port_in
buffer_size = 1024
data = gl.data # Only if no player connected

# sens.positive is used only to run this script once: sens is positive only 0 to 1, not 1 to 0
cont = gl.getCurrentController()
sens = cont.sensors["Get OSC"]

if sens.positive:
    # Connect Blender
    if not gl.connected :
        try:
            gl.sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
            gl.sock.bind((ip, port))
            gl.sock.setblocking(0)
            gl.sock.settimeout(0.005)
            gl.sock.setsockopt(socket.SOL_SOCKET, socket.SO_RCVBUF, buffer_size)
            print()
            print("Socket :")
            print(' Blender Receive OSC data \n on IP = {} \n Port = {} \n with Buffer = {} \n'.format(ip, port, buffer_size))
            gl.connected = True
        except:
            print('No connected to IP={} Port={}'.format(ip, port), "\n")
            pass

    # If Blender connected
    if gl.connected :
        try:
            raw_data = gl.sock.recv(buffer_size)
            data = OSC.decodeOSC(raw_data)

        except socket.error:
            print("Socket Error: gl.connected is set to True")
            pass

    # Save
    gl.data = data

# Increase and reset tempo
gl.tempo += 1
if gl.tempo == 60:
    gl.tempo = 0
    # print some
    print(data)
